/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';
import CouponProblem from './problem';
import CouponSimple from './constructor';
import Coupon from './methods';

describe('basic class', () => {
  it('should make a class', () => {
    const coupon = new CouponProblem();
    expect(coupon instanceof CouponProblem).toEqual(true);
  });

  it('should set properties', () => {
    const coupon = new CouponSimple(5);
    expect(coupon.price).toEqual(5);
    expect(coupon.expiration).toEqual('two weeks');
  });

  it('should have methods', () => {
    const coupon = new Coupon(5);
    const message = 'This offer expires in two weeks.';

    expect(coupon.getPriceText()).toEqual('$ 5');
    expect(coupon.getExpirationMessage()).toEqual(message);
  });
});
