/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
function* getCairoTrilogy() {
  yield 'Palace Walk';
  yield 'Palace of Desire';
  yield 'Sugar Street';
}

const trilogy = getCairoTrilogy();
trilogy.next();
// { value: 'Palace Walk', done: false }
trilogy.next();
// { value: 'Palace of Desire', done: false }
trilogy.next();
// { value: 'Sugar Street', done: false }
trilogy.next();
// { value: undefined, done: true }

[...getCairoTrilogy];
// [ 'Palace Walk', 'Palace of Desire', 'Sugar Street']

const readingList = {
  'Visit from the Goon Squad': true,
  'Manhattan Beach': false,
};
for (const book of getCairoTrilogy()) {
  readingList[book] = false;
}
readingList;
// {
//   'Visit from the Goon Squad': true,
//   'Manhattan Beach': false,
//   'Palace Walk': false,
//   'Palace of Desire': false,
//   'Sugar Street': false
// }


export { getCairoTrilogy };
