/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
class Coupon {
  constructor(price, expiration) {
    this._price = price;
    this.expiration = expiration || 'Two Weeks';
  }

  get priceText() {
    return `$${this._price}`;
  }

  get price() {
    return this._price;
  }

  set price(price) {
    const newPrice = price
      .toString()
      .replace(/[^\d]/g, '');
    this._price = newPrice;
  }

  get expirationMessage() {
    return `This offer expires in ${this.expiration}`;
  }
}

const coupon = new Coupon(5);
coupon.price;
// 5

coupon.price = '$10';

coupon.price;
// 10

coupon.priceText;
// $ 10
export default Coupon;
