/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
class Coupon {
  constructor(price, expiration) {
    this.price = price;
    this.expiration = expiration || 'two weeks';
  }

  get priceText() {
    return `$ ${this.price}`;
  }

  get expirationMessage() {
    return `This offer expires in ${this.expiration}.`;
  }
}

const coupon = new Coupon(5);
coupon.price = 10;
coupon.priceText;
// '$10'
coupon.messageText;
// 'This offer expires in two weeks.
coupon.messageText;

export default Coupon;
