/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable func-names */
class Coupon {
  constructor(price, expiration) {
    this.price = price;
    this.expiration = expiration || 'Two Weeks';
  }

  getExpirationMessage() {
    return `This offer expires in ${this.expiration}.`;
  }
}

const saleCoupon = new Coupon(5, 'two months');
saleCoupon.getExpirationMessage();
// This offer expires in two months.


class FlashCoupon extends Coupon {
  constructor(...args) {
    super(args);
    this.expiration = 'Two Hours';
  }

  getExpirationMessage() {
    return `This is a flash offer and expires in ${this.expiration}`;
  }
}

export { Coupon, FlashCoupon };
