/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable func-names */
function Coupon(price, expiration) {
  this.price = price;
  this.expiration = expiration || 'two weeks';
}
const coupon = new Coupon(5, 'two months');
coupon.price;
// 5

Coupon.prototype.getExpirationMessage = function () {
  return `This offer expires in ${this.expiration}.`;
};
coupon.getExpirationMessage();
// This offer expires in two months.


class FlashCoupon extends Coupon {
  constructor(price, expiration) {
    super(price);
    this.expiration = expiration || 'two hours';
  }

  getExpirationMessage() {
    return `This is a flash offer and expires in ${this.expiration}.`;
  }
}

export { Coupon, FlashCoupon };
