/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';

import { Coupon, FlashCoupon } from './prototypes';

describe('prototypes', () => {
  it('should have methods on a prototype', () => {
    const coupon = new Coupon(5, 'two months');
    const message = 'This offer expires in two months.';
    expect(coupon.price).toEqual(5);
    expect(coupon.getExpirationMessage()).toEqual(message);
  });

  it('should extend a prototype', () => {
    const flash = new FlashCoupon(5);
    const message = 'This is a flash offer and expires in two hours.';
    expect(flash.price).toEqual(5);
    expect(flash.getExpirationMessage()).toEqual(message);
  });
});
