/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';
import { addBookDefaults } from './problem';

describe('Assign tests', () => {
  const defaults = {
    author: '',
    title: '',
    year: 2017,
    rating: null,
  };

  const book = {
    title: 'Simplifying JavaScript',
    author: 'Joe Morgan',
  };

  it('should add defaults', () => {
    const bookUpdated = addBookDefaults(book, defaults);
    expect(bookUpdated.title).toEqual('Simplifying JavaScript');
    expect(bookUpdated.year).toEqual(2017);
  });

  it('should add defaults with assign', () => {
    const copy = Object.assign({}, defaults);
    const book2 = {
      title: 'Another book',
      year: 2016,
    };
    const bookUpdated = Object.assign(copy, book);
    expect(bookUpdated.title).toEqual('Simplifying JavaScript');
    expect(bookUpdated.author).toEqual('Joe Morgan');
    const bookUpdated2 = Object.assign(copy, book2);
    expect(bookUpdated2.title).toEqual('Another book');
    expect(bookUpdated2.author).toEqual('Joe Morgan');
  });

  it('should add defaults with assign', () => {
    const bookUpdated = Object.assign({}, defaults, book);
    expect(bookUpdated.title).toEqual('Simplifying JavaScript');
    expect(bookUpdated.year).toEqual(2017);
  });
});
