/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable no-unused-vars */

function updateBookYear() {
//  
  const book = {
    title: 'Reasons and Persons',
    author: 'Derek Parfit',
  };

  const update = { ...book, year: 1984 };

  // { title: 'Reasons and Persons', author: 'Derek Parfit', year: 1984}
  //  
  return update;
}

function updateBookTitle() {
//  
  const book = {
    title: 'Reasons and Persons',
    author: 'Derek Parfit',
  };

  const update = { ...book, title: 'Reasons & Persons' };

  // { title: 'Reasons & Persons', author: 'Derek Parfit' }
  //  
  return update;
}

function addBookDefaults() {
  //  
  const defaults = {
    author: '',
    title: '',
    year: 2017,
    rating: null,
  };

  const book = {
    author: 'Joe Morgan',
    title: 'ES6 Tips',
  };


  const bookWithDefaults = { ...defaults, ...book };

  // {
  //   author: 'Joe Morgan',
  //   title: 'ES6 Tips',
  //   year: 2017,
  //   rating: null,
  // }
  //  

  return bookWithDefaults;
}

function deepMerge() {
  const defaultEmployee = {
    name: {
      first: '',
      last: '',
    },
    years: 0,
  };
  // 
  const employee = {
    ...defaultEmployee,
    name: {
      ...defaultEmployee.name,
    },
  };
  // 

  employee.name.first = 'joe';
  return [defaultEmployee.name.first, employee.name.first];
}
export { addBookDefaults, deepMerge, updateBookTitle, updateBookYear };
