/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';
import { getArtistByPreference, getTheme } from './async';
import { getArtistByPreference as catchPref } from './catch';

describe('async', () => {
  it('should await an action', () => {
    return getTheme()
      .then(theme => {
        expect(theme).toEqual('dusk');
      });
  });

  it('should await on multiples actions', () => {
    return getArtistByPreference()
      .then(artist => {
        expect(artist).toEqual('Brian Eno');
      });
  });

  it('should catch an error', () => {
    return catchPref()
      .then(() => {
        // Hitting this block is an error.
        expect(false).toEqual(true);
      })
      .catch(e => {
        expect(e.type).toEqual('Network error');
      });
  });
});
