/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
// Include filter preferences.

function saveBreed(breed) {
  localStorage.setItem('breed', breed);
}

function getSavedBreed() {
  return localStorage.getItem('breed');
}

function removeBreed() {
  return localStorage.removeItem('breed');
}

function applyBreedPreference(filters) {
  const breed = getSavedBreed();
  if (breed) {
    filters.set('breed', breed);
  }
  return filters;
}

function savePreferences(filters) {
  const filterString = JSON.stringify([...filters]);
  localStorage.setItem('preferences', filterString);
}

function retrievePreferences() {
  const preferences = JSON.parse(localStorage.getItem('preferences'));
  return new Map(preferences);
}

function clearPreferences() {
  localStorage.clear();
}

export {
  applyBreedPreference,
  clearPreferences,
  getSavedBreed,
  removeBreed,
  retrievePreferences,
  saveBreed,
  savePreferences,
};
