/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';

import { validator } from './context';

import {
  validator as validatorBasic,
} from './basic';

import {
  validator as validatorProblem,
} from './problem';

import {
  validator as validatorMethod,
} from './method';


describe('validation', () => {
  const field = 'city';
  it('should set invalid message', () => {
    const message = 'city is invalid.';
    expect(validatorBasic.setInvalidMessage(field)).toEqual(message);
  });
  it('should not access context on map function', () => {
    try {
      validatorProblem.setInvalidMessages(field);
      // TypeError: Cannot read property 'message' of undefined
    } catch (e) {
      expect(e.message).toEqual("Cannot read property 'message' of undefined");
    }
  });

  it('should access context with arrow function', () => {
    const messages = ['city is invalid.'];
    expect(validator.setInvalidMessages(field)).toEqual(messages);
  });

  it('should not access context on map function', () => {
    try {
      validatorMethod.setInvalidMessage(field);
      // TypeError: Cannot read property 'message' of undefined
    } catch (e) {
      expect(e.message).toEqual("Cannot read property 'message' of undefined");
    }
  });
});
