/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';

import {
  getDogNames as getNamesFull,
} from './problem';

import {
  allFilters,
  anyFilters,
  dogs,
  getDogNames,
  colorCheck,
  stateCheck,
  weightCheck,
} from './curry';

describe('curry', () => {
  it('should apply a function without currying', () => {
    expect(getNamesFull(dogs, ['color', 'black'])).toEqual(['max', 'don']);
  });
  it('should get dog names with regular function', () => {
    expect(getDogNames(dogs, dog => dog.color === 'black')).toEqual(['max', 'don']);
  });
  it('should get dog names with curried function', () => {
    expect(getDogNames(dogs, weightCheck(20))).toEqual(['max']);
  });
  it('should get dog names with curried function', () => {
    expect(getDogNames(dogs, weightCheck(20))).toEqual(['max']);
  });
  it('should apply multiple functions', () => {
    expect(allFilters(dogs, colorCheck('black'), stateCheck('kansas'))).toEqual(['don']);
  });
  it('should apply multiple functions', () => {
    expect(allFilters(dogs, colorCheck('black'), stateCheck('kansas'))).toEqual(['don']);
  });
  it('should apply multiple functions', () => {
    expect(anyFilters(dogs, weightCheck(20), colorCheck('chocolate'))).toEqual(['max', 'shadow']);
  });
});
