/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';
import { greetWithExcitement, key, capitalize, greet, formatUser } from './arrow';
import {
  key as keyF,
  capitalize as capitalizeF,
  formatUser as formatUserF,
  greetWithExcitement as greetWithExcitementF,
} from './full';

describe('full functions', () => {
  it('should take no parameters', () => {
    expect(keyF()).toEqual('abc123');
  });

  it('should take one parameter', () => {
    expect(capitalizeF('joe')).toEqual('Joe');
  });

  it('should take several parameters', () => {
    expect(greetWithExcitementF('mark')).toEqual('Oh, hi Mark!');
  });

  it('should have implicit return', () => {
    expect(formatUserF('joe')).toEqual('Joe is logged in.');
  });

  it('should take a callback', () => {
    expect(greetWithExcitementF()).toEqual('Oh, hi Mark!');
  });
});

describe('arrow functions', () => {
  it('should take no parameters', () => {
    expect(key()).toEqual('abc123');
  });

  it('should take one parameter', () => {
    expect(capitalize('joe')).toEqual('Joe');
  });

  it('should take several parameters', () => {
    expect(greet('joe', 'morgan')).toEqual('Oh, hi Joe Morgan');
  });

  it('should have implicit return', () => {
    expect(formatUser('joe')).toEqual('Joe is logged in.');
  });

  it('should take a callback', () => {
    expect(greetWithExcitement()).toEqual('Oh, hi Mark!');
  });
});
