/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
const students = [
  {
    focus: 'nagarjuna',
  },
  {
    focus: 'logic',
  },
  {
    focus: 'consciousness',
  },
  {
    focus: '',
  },
  {
    focus: 'logic',
  },
];

const focuses = students
  .map(student => student.focus)
  .filter(focus => focus)
  .reduce((focuses, focus) => {
    const count = focuses.get(focus) || 0;
    focuses.set(focus, count + 1);
    return focuses;
  }, new Map());

const formattedFocus = [...focuses]
  .sort()
  .map(([name, count]) => `${name}: ${count}`);

formattedFocus;

const sailors = [
  {
    name: 'yi hong',
    active: true,
    email: 'yh@yhproductions.io',
  },
  {
    name: 'alex',
    active: true,
    email: '',
  },
  {
    name: 'nathan',
    active: false,
    email: '',
  },
];

function sendActiveMemberEmail(sailors, sendEmail) {
  sailors
    .filter(sailor => sailor.active)
    .map(sailor => sailor.email || `${sailor.name}@wiscsail.io`)
    .forEach(sailor => sendEmail(sailor));
}

export { sailors, sendActiveMemberEmail };
