/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable no-unused-vars */

const team = [
  'Michelle B',
  'Dave L',
  'Dave C',
  'Courtney B',
  'Davina M',
];

function getDaveVariants(team) {
  const daves = team.filter(member => member.match(/Dav/));
  return daves;
}

const instructors = [
  {
    name: 'Jim',
    libraries: ['MERIT'],
  },
  {
    name: 'Sarah',
    libraries: ['Memorial', 'SLIS'],
  },
  {
    name: 'Eliot',
    libraries: ['College Library'],
  },
];

function findMemorialInstructor(instructors) {
  const librarian = instructors.find(instructor => {
    return instructor.libraries.includes('Memorial');
  });

  return librarian;
}

function findAnyInstructor(instructors) {
  const findByLibrary = library => instructor => {
    return instructor.libraries.includes(library);
  };
  const librarian = instructors.find(findByLibrary('MERIT'));

  // {
  //   name: 'Jim',
  //   libraries: ['MERIT'],
  // }

  return librarian;
}

const scores = [30, 82, 70, 45];
function getNumberOfPassingScores(scores) {
  const passing = scores.filter(score => score > 59);
  // [70, 82]
  return passing.length;
}
// 2


function getPerfectScores(scores) {
  const perfect = scores.filter(score => score === 100);
  // []
  return perfect.length;
}
// 0


export {
  scores,
  getDaveVariants,
  findAnyInstructor,
  findMemorialInstructor,
  getNumberOfPassingScores,
  getPerfectScores,
  instructors,
  team,
};
