/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
function checkConflicts(firms, isAvailable) {
  const message = [...firms].reduce((availability, firm) => {
    const [id, name] = firm;
    if (!isAvailable(id)) {
      return `${name} is not available`;
    }
    return availability;
  }, 'All firms are available');
  return message;
}

function findConflicts(firms, isAvailable) {
  const unavailable = [...firms].find(firm => {
    const [id] = firm;
    return !isAvailable(id);
  });

  if (unavailable) {
    return `${unavailable[1]} is not available`;
  }

  return 'All firms are available';
}

function isValid(registration) {
  const message = Object.keys(registration).reduce((valid, field) => {
    if (!registration[field]) {
      return `You are missing ${field}`;
    }
    return valid;
  }, '');
  return message || 'Thank You';
}

export { checkConflicts, findConflicts, isValid };
