/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable no-unused-vars, prefer-const */

function noChange() {
  const names = ['walter', 'white'];
  const capitalized = names.forEach(name => name.toUpperCase());

  capitalized;
  // undefined
  return capitalized;
}

function mutateChange() {
  const names = ['walter', 'white'];
  let capitalized = [];
  names.forEach(name => capitalized.push(name.toUpperCase()));

  capitalized;
  // ['WALTER', 'WHITE'];

  return capitalized;
}

const sailingClub = [
  'yi hong',
  'andy',
  'darcy',
  'jessi',
  'alex',
  'nathan',
];

function sendInvitation(sailingClub, sendEmail) {
  sailingClub.forEach(member => sendEmail(member));
}

export { mutateChange, noChange, sailingClub, sendInvitation };
