/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';
import sinon from 'sinon';

import { sendInvitation as sendInvitationFull } from './full';
import { mutateChange, noChange, sailingClub, sendInvitation } from './forEach';

describe('forEach', () => {
  it('should send an email to each person with a for loop', () => {
    const sendInvitationSpy = sinon.spy();
    sendInvitationFull(sailingClub, sendInvitationSpy);
    expect(sendInvitationSpy.getCalls().length).toEqual(6);
  });

  it('should send an email to each person', () => {
    const sendInvitationSpy = sinon.spy();
    sendInvitation(sailingClub, sendInvitationSpy);
    expect(sendInvitationSpy.getCalls().length).toEqual(6);
  });

  it('should not make a change on a forEach loop', () => {
    expect(noChange()).toEqual(undefined);
  });

  it('should mutate an array on a forEach loop', () => {
    expect(mutateChange()).toEqual(['WALTER', 'WHITE']);
  });
});
