/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
/* eslint-disable no-unused-vars */

// 
const band = [
  {
    name: 'corbett',
    instrument: 'guitar',
  },
  {
    name: 'evan',
    instrument: 'guitar',
  },
  {
    name: 'sean',
    instrument: 'bass',
  },
  {
    name: 'brett',
    instrument: 'drums',
  },
];
// 


function getInstruments() {
  function getInstrument(member) {
    return member.instrument;
  }

  const instruments = band.map(getInstrument);
  // ['guitar', 'guitar', 'bass', 'drums']
  return instruments;
}

function getInstruments2() {

  const instruments = band.map(member => member.instrument);
  // ['guitar', 'guitar', 'bass', 'drums']
  return instruments;
}

function getDogs(env) {
  return () => {
    if (env === 'production') {
      return fetch('http://dog.foo');
    }
    return fetch('http://localhost:8888');
  };
}

function getCats(env) {
  return () => {
    if (env === 'production') {
      return fetch('http://dog.foo');
    }
    return fetch('http://localhost:8888');
  };
}

function setUpLocal(...fetchers) {
  return fetchers.map(fetcher => fetcher('local'));
}

export { getInstruments, getInstruments2 };
