/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';

import { getLowestPrice } from './let';
import { getLowestPrice as getLowestPriceVar } from './problem';
import { getLowestPrice as getLowestPriceConst } from './const';

describe('let block lowest price', () => {
  it('should return none avaible', () => {
    //    
    const item = {
      inventory: 0,
      price: 3,
      salePrice: 0,
      saleInventory: 0,
    };
    //    

    expect(getLowestPriceVar(item)).toEqual(0);
  });

  it('should get sale price', () => {
    //    
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 1,
    };
    //    
    expect(getLowestPriceVar(item)).toEqual(2);
  });

  it('should get incorrect inventory', () => {
    //    
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 0,
    };
    //    
    expect(getLowestPriceVar(item)).toEqual(0);
  });
});

describe('let block lowest price let', () => {
  it('should return none avaible', () => {
    const item = {
      inventory: 0,
      price: 3,
      salePrice: 0,
      saleInventory: 0,
    };

    expect(getLowestPrice(item)).toEqual(0);
  });

  it('should get sale price', () => {
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 1,
    };
    expect(getLowestPrice(item)).toEqual(2);
  });

  it('should get incorrect inventory', () => {
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 0,
    };
    expect(getLowestPrice(item)).toEqual(3);
  });
});

describe('let block lowest price const', () => {
  it('should return none avaible', () => {
    const item = {
      inventory: 0,
      price: 3,
      salePrice: 0,
      saleInventory: 0,
    };

    expect(getLowestPriceConst(item)).toEqual(0);
  });

  it('should get sale price', () => {
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 1,
    };
    expect(getLowestPriceConst(item)).toEqual(2);
  });

  it('should get incorrect inventory', () => {
    const item = {
      inventory: 3,
      price: 3,
      salePrice: 2,
      saleInventory: 0,
    };
    expect(getLowestPriceConst(item)).toEqual(3);
  });
});
