/***
 * Excerpted from "Simplifying JavaScript",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/es6tips for more book information.
***/
import expect from 'expect';

import { addClick } from './problem';
import { addClick as addClickCurry } from './curry';
import { addClick as addClickLet } from './scope';

describe('let scope', () => {
  it('should have a scope problem', () => {
    const items = [
      {},
      {},
    ];
    addClick(items);
    expect(items[0].onClick()).toEqual(2);
    expect(items[1].onClick()).toEqual(2);
  });

  it('should not have a  problem', () => {
    const items = [
      {},
      {},
    ];
    addClickCurry(items);
    expect(items[0].onClick()).toEqual(0);
    expect(items[1].onClick()).toEqual(1);
  });

  it('should not have a  problem', () => {
    const items = [
      {},
      {},
    ];
    addClickLet(items);
    expect(items[0].onClick()).toEqual(0);
    expect(items[1].onClick()).toEqual(1);
  });
});
